<!doctype html>
<html class="no-js" lang="">

<head>
  <meta charset="utf-8">
  <title>Chat</title>
  <meta name="description" content="">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <link rel="apple-touch-icon" href="icon.png">
  <!-- Place favicon.ico in the root directory -->

  <meta name="theme-color" content="#fafafa">
  <style>
    div#sendform-container {
      position: fixed;
      bottom: 0;
      left: 0;
      width: 100vw;
      display: flex;
      margin: auto 0 0;
    }

    #messagetext {
      flex-grow: 1;
    }

    .messagecontainer {
      font-family: sans-serif;
      font: -apple-system-body;
      border-bottom: solid 1px #9f9f9f;
    }

    .topcontent {
      font-size: 12px;
      margin-top: 5px;
    }

    .contentcontainer {
      margin-top: 5px;
    }

    .attachmentImage {
      max-height: calc(0.40 * 100vh);
      max-width: 100%;
    }

    .blackoverlay {
      background-color: black;
      position: fixed;
      width: 100vw;
      height: 100vh;
      margin: auto;
      top: 0;
      bottom: 0;
      left: 0;
      right: 0;
      z-index: 999;
      text-align: center;
    }

    .blackoverlay .attachmentImage {
      height: 100vh;
    }

    .blackoverlay .closeEnlargementButton {
      position: absolute;
      top: 10px;
      right: 20px;
      color: white;
      font-size: 30px;
      cursor: pointer;
    }
  </style>
</head>

<body>
<!--[if IE]>
<p class="browserupgrade">You are using an <strong>outdated</strong> browser. Please <a href="https://browsehappy.com/">upgrade
  your browser</a> to improve your experience and security.</p>
<![endif]-->
<div id="messages">

</div>
<div id="sendform-container">
  <input id="messagetext" type="text">
  <input type="button" value="Verzend" id="messagebutton" onclick="sendMessage(this)">
</div>
<script>
    window.onload = function () {
        document.getElementById("messages").style.marginBottom = document.getElementById("sendform-container").clientHeight + "px";
        getAndLoadMessageHistory(function () {
            initialiseWS();
        });
        document.getElementById("messagetext").addEventListener("keyup", function (e) {
            if (e.key === "Enter") {
                document.getElementById("messagebutton").click();
            }
        });
    };

    function addMessage(message) {
        var user = message["user"];
        var timestamp = message["timestamp"];
        var imgpath = message["imgpath"];
        var content = message["message"];
        var id = message["id"];

        if (!user || !timestamp || !id) {
            return;
        }

        var messagecontainer = document.createElement("div");
        messagecontainer.className = "messagecontainer";
        messagecontainer.id = "message" + id;

        //topcontent is username + timestamp
        var topcontent = document.createElement("p");
        topcontent.innerHTML = "<b>" + user + "</b> - " + timestamp;
        topcontent.className = "topcontent";
        messagecontainer.appendChild(topcontent);

        var contentcontainer = document.createElement("p");
        contentcontainer.innerHTML = content;
        contentcontainer.className = "contentcontainer";
        messagecontainer.appendChild(contentcontainer);

        if (imgpath || imgpath !== "") {
            var image = document.createElement("img");
            image.src = imgpath;
            image.id = "image" + id;
            image.className = "attachmentImage";
            image.title = "Bijgevoegde afbeelding";
            image.setAttribute("onclick", "enlargeImage(this);");
            messagecontainer.appendChild(image);
        }

        document.getElementById("messages").appendChild(messagecontainer);
        window.scrollTo(0, document.body.scrollHeight);
    }

    function enlargeImage(imageEl) {
        var overlay = document.createElement("div");
        overlay.className = "blackoverlay";
        document.body.appendChild(overlay);

        var closebutton = document.createElement("span");
        closebutton.className = "closeEnlargementButton";
        closebutton.innerHTML = "&times;";
        closebutton.setAttribute("onclick", "closeEnlargement()");
        overlay.appendChild(closebutton);

        overlay.appendChild(imageEl);
    }

    function closeEnlargement() {
        var image = document.querySelector(".blackoverlay .attachmentImage");
        var messageid = parseInt(image.id.replace(/^\D+/g, ''));
        document.getElementById("message" + messageid).appendChild(image);
        document.querySelector(".blackoverlay").remove();
    }

    function sendMessage(button) {
        var message = document.getElementById("messagetext").value;
        if (message != null) {
            button.disabled = true;
            var xhttp = new XMLHttpRequest();
            xhttp.onreadystatechange = function () {
                if (this.readyState === 4) {
                    button.disabled = false;
                    if (this.status === 200) {
                        document.getElementById("messagetext").value = "";
                    }
                }
            };
            var formdata = new FormData();
            formdata.append("sessionId", $_GET["sessionId"]);
            formdata.append("message", message);
            xhttp.open("POST", "https://augustus.romereis-hl.nl/sendmessage.php", true);
            xhttp.send(formdata);
        }
    }
</script>
<script src="js/chatwebsocket.js"></script>
</body>

</html>
